class SVG
  class Plot
    def plot(
      xraw, yraw,
      minx: @minx,maxx:  @maxx,miny:  @miny,maxy:  @maxy,
      label:  nil,
      color: nil,
      marker: nil,
      linestyle: nil,
      opacity:  nil,
      xlog: false,ylog: false)

      self.set_plot_style(label,color,marker,linestyle,opacity)
      points = self.map_and_zip(xraw,yraw,minx,maxx,miny,maxy,xlog,ylog)
      
      @svg.g(
        id: @labels.last,
        stroke: @colors.last, 
        fill: @colors.last, 
        stroke_width: @linewidth,
        opacity: @opacities.last) do |g|

          g.path(title: @labels.last,fill: "none",stroke_dasharray: self.linestyle(@linestyles.last)) do |path|
          missing = true
          points.each do |(x,y)|
            if !x.finite? || !y.finite?
              missing = true 
              next
            end 
            if missing 
              path.m(x,y)
              missing = false
            end 
            path.l(x,y) 
          end 
        end 
      
        g.g(id: @labels.last+"-markers", fill: @colors.last) do |mg| 
          points.each_with_index do |(x,y),i|
            next if ((i % (points.size.to_i / @markernum.to_i)) != 0) || !x.finite? || !y.finite?
            self.marker(@markers.last,x,y,yraw[i].round(2))
          end 
        end 
      end  

    end
  end
end 
