require "stringio"

class SVG
  attr :width
  attr :height
  def initialize(io,width,height)
    @io = io
    @width = width
    @height = height
  end 
  def puts(*args)
    @io.puts(*args)
  end 
  def print(*args)
    @io.print(*args)
  end 
  def self.new(x:,y:,width:,height:,io: STDOUT,**args)
    svg = super(io,width,height)
    svg.print %(<svg viewBox="#{x} #{y} #{width} #{height}" version="1.1" xmlns="http://www.w3.org/2000/svg" )
    svg.print_args(**args)
    svg.print(" >")
    yield svg
    svg.puts "</svg>"
  end
  def print_args(**args)
    args.each do |k,v|
      @io.print k.to_s.gsub("_","-"),"=","\"",v,"\""," "
    end 
  end
  def print_title(title)
    @io.puts %(<title>#{title}</title>) if title != ""
  end 
end 

require "shapes"
require "text"
require "containers"
require "transform"
require "plot2d"
